public class Ball
{
    private int radius;
    private String farbe;
    private int x;
    private int y;
    private int vX;
    private int vY;
    private int g = 2; //"Gravitationskonstante"
    private int t = 0; //Flugzeit
    
    private KREIS symbol;
        
    
    //  K O N S T R U K T O R E N
    
    /**
     * Konstruktor fuer Objekte der Klasse Ball.
     */
    public Ball()
    {
        radius = 5;
        farbe = "weiss";
        this.x = 400;
        this.y = 300;
        vX = 0;
        vY = 1;
        
        symbol = new KREIS();
        symbol.setzeRadius(radius);
        symbol.setzeFarbe(farbe);
        symbol.setzeMittelpunkt(x, y);
    }
    
    public Ball(int radius, String farbe, int x, int y) {
        radius = radius;
        farbe = farbe;
        this.x = x;
        this.y = y;
        //vX = (int)(Math.random()*3+1);
        //vY = (int)(Math.random()*3+1);
        vX = 0;
        vY = 1;
        
        symbol = new KREIS();
        symbol.setzeRadius(radius);
        symbol.setzeFarbe(farbe);
        symbol.setzeMittelpunkt(x, y);
    }
    
    
    
    //  G E T T E R - M E T H O D E N
    
    /**
     * Methode zum Nennen des Radius des Balls.
     * 
     * @return  radius  (aktueller Radius des Balls)
     */
    public int nenneRadius() {
        return radius;
    }
    
    
    /**
     * Methode zum Nennen der Farbe des Balls.
     * 
     * @return  radius  (aktuelle Farbe des Balls)
     */
    public String nenneFarbe() {
        return farbe;
    }
    
    
    /**
     * Methode zum Nennen der yxKoordinate des Balls.
     * 
     * @return  radius  (aktuelle x-Koordinate des Balls)
     */
    public int nenneX() {
        return x;
    }
    
    
    /**
     * Methode zum Nennen der y-Koordinate des Balls.
     * 
     * @return  radius  (aktuelle y-Koordinate des Balls)
     */
    public int nenneY() {
        return y;
    }
    
    
    /**
     * Methode zum Nennen der Geschwindigkeit des Balls in x-Richtung.
     * 
     * @return  vX  (aktuelle Geschwindigkeit des Balls in x-Richtung)
     */
    public int nenneVX() {
        return vX;
    }
    
    
    /**
     * Methode zum Nennen der Geschwindigkeit des Balls in y-Richtung.
     * 
     * @return  vY  (aktuelle Geschwindigkeit des Balls in y-Richtung)
     */
    public int nenneVY() {
        return vY;
    }
    
    
    
    //  S E T T E R - M E T H O D E N
    
    /**
     * Methode zum Setzen des Radius des Balles.
     * 
     * @param   radius  (neuer Radius des Balls)
     */
    public void setzeRadius(int radius) {
        this.radius = radius;
        symbol.setzeRadius(radius);
    }
    
    
    /**
     * Methode zum Setzen der Farbe des Balles.
     * 
     * @param   farbe  (neue farbe des Balls)
     */
    public void setzeFarbe(String farbe) {
        this.farbe = farbe;
        symbol.setzeFarbe(farbe);
    }
    
    
    /**
     * Methode zum Setzen der x-Koordinate des Balles.
     * 
     * @param   x  (neue x-Koordinate des Balls)
     */
    public void setzeX(int x) {
        this.x = x;
        symbol.setzeMittelpunkt(this.x, this.y);
    }
    
    
    /**
     * Methode zum Setzen der y-Koordinate des Balles.
     * 
     * @param   y  (neue y-Koordinate des Balls)
     */
    public void setzeY(int y) {
        this.y = y;
        symbol.setzeMittelpunkt(this.x, this.y);
    }
    
    
    /**
     * Methode zum Setzen der Geschwindigkeit des Balles in x-Richtung.
     * 
     * @param   vX  (neue Geschwindigkeit des Balles in x-Richtung)
     */
    public void setzeVX(int vX) {
        this.vX = vX;
    }
    
    
    /**
     * Methode zum Setzen der Geschwindigkeit des Balles in y-Richtung.
     * 
     * @param   vY  (neue Geschwindigkeit des Balles in y-Richtung)
     */
    public void setzeVY(int vY) {
        this.vY = vY;
    }
    
    
    
    //  W E I T E R E   M E T H O D E N
    
    
    /**
     * Methode zum Bewegen des Balls mit der aktuellen Geschwindigkeit in x- und y-Richtung.
     * 
     */public void bewegen(int ticks) {
        
        if ( y < 5   ||   y > 595 ) { //Abprallen horizontal
            vY = -1 * (int)(vY); //Der Vorfaktor ist die prozentuale Energieerhaltung ist die Dmpfung
        }
        
        if ( x < 5   ||   x > 795 ) { //Abprallen waagerecht
            vX = -1 * (int)(vX);
        }
        
        if (y<600) {
            if (ticks%20==0 && vY<6) { //Jeder x. tick erhhen          
                vY = vY + 1;
            }
        }
        x = x + vX;
        y = y + vY;
        symbol.setzeMittelpunkt(x, y);
    }
   
    public void vorzeichenVonVyAendern() {
        vY = -1 * vY;
    }
    
    public void vorzeichenVonVxAendern() {
        vX = -1 * vX;
    }
    
    
}
