import ea.edu.AnzeigeE;

/**
 * Diese Klasse ermoeglicht das Anmelden von EDU-Interfaces.<br />
 * Zusaetzlich laesst sich hiermit ein Punktestand einblenden.
 */
public class MANAGER
extends AnzeigeE {
    
    /**
     * Meldet ein TICKER-Interface an. <br />
     * Sobald diese Anmeldung erfolgreich abgeschlossen wurde, wird der TICKER in seiner Intervallschaltung aufgerufen.
     * @param   ticker  Der anzumeldende Ticker. Dies muss ein Objekt einer Klasse sein, die das Interface <code>TICKER</code> 
     * implementiert.
     * @param   intervall   Das Intervall (<i>in Millisekunden</i>), in dem dieser Ticker aufgerufen wird.
     * @see TICKER
     * @see tickerAbmelden(TICKER)
     */
    public void tickerAnmelden(TICKER ticker, int intervall) {
        super.tickerAnmelden(ticker, intervall);
    }
    
    /**
     * Meldet ein TICKER-Interface ab. <br />
     * Sobald diese Abmeldung erfolgreich abgeschlossen wurde, wird der TICKER nicht mehr gemaess seiner 
     * Intervallschaltung aufgerufen.
     * @param   ticker  Der abzumeldende TICKER. War dieser Ticker abgemeldet passiert gar nichts.
     * @see tickerAnmelden(TICKER, int)
     */
    public void tickerAbmelden(TICKER ticker) {
        super.tickerAbmelden(ticker);
    }
    
    /**
     * Meldet ein TASTENREAGIERBAR-Interface an.<br />
     * Sobald diese Anmeldung erfolgreich abgeschlossen wurde, wird das TASTENREAGIERBAR-Interface bei jedem Tastendruck
     * informiert, indem seine <code>tasteReagieren</code>-Methode aufgerufen wurde.
     * @see TASTENREAGIERBAR
     */
    public void tastenReagierbarAnmelden(TASTENREAGIERBAR tastenreagierbar) {
        super.tastenReagierbarAnmelden(tastenreagierbar);
    }
    
    /**
     * Setzt den Punktestand auf der linken Seite neu.
     * @param   punkte  Dieser Punktestand wird ab sofort auf der linken Seite angezeigt.
     */
    public void punkteLinksSetzen(int punkte) {
        super.punkteLinksSetzen(punkte);
    }
    
    /**
     * Setzt den Punktestand auf der rechten Seite neu.
     * @param   punkte  Dieser Punktestand wird ab sofort auf der rechten Seite angezeigt.
     */
    public void punkteRechtsSetzen(int punkte) {
        super.punkteRechtsSetzen(punkte);
    }
}
