
/**
 * Klasse Schlaeger zur Beschreibung der logischen Struktur eines Schaegers im Spiel PingPong.
 * 
 * @author      mike ganshorn
 * @version     2011-05-28
 */
public class Schlaeger
{
    private int breite;
    private int hoehe;
    private String farbe;
    private int x;
    private int y;
    private int vX;
    private int vY;
    
    private RECHTECK symbol;
    
    
    //  K O N S T R U K T O R E N
    
    /**
     * Konstruktor fuer Objekte der Klasse Schlaeger.
     */
    public Schlaeger()
    {
       this.breite = 10;
       this.hoehe = 100;
       this.farbe = "blau";
       this.x = 10;
       this.y = 300;
       this.vX = 0;
       this.vY = 1;
       
       this.symbol = new RECHTECK();
       this.symbol.setzeGroesse(this.breite, this.hoehe);
       this.symbol.setzeFarbe(this.farbe);
       this.symbol.setzeMittelpunkt(this.x, this.y);
    }
    
    
    /**
     * Konstruktor fuer Objekte der Klasse Schlaeger.
     * 
     * @param   breite  (neue Breite des Schlaegers)
     * @param   hoehe   (neue Hoehe des Schlegers)
     * @param   farbe   (neue Farbe des Schlaegers)
     * @param   x       (neue x-Koordinate des Schlagers)
     * @param   y       (neue y-Koordinate des Schlaegers)
     */
    public Schlaeger(int breite, int hoehe, String farbe, int x, int y)
    {
       this.breite = breite;
       this.hoehe = hoehe;
       this.farbe = farbe;
       this.x = x;
       this.y = y;
       this.vX = 0;
       this.vY = 1;
       
       this.symbol = new RECHTECK();
       this.symbol.setzeGroesse(this.breite, this.hoehe);
       this.symbol.setzeFarbe(this.farbe);
       this.symbol.setzeMittelpunkt(this.x, this.y);
    }
    
    
    /**
     * Konstruktor fuer Objekte der Klasse Schlaeger.
     * 
     * @param   farbe   (neue Farbe des Schlaegers)
     * @param   x       (neue x-Koordinate des Schlagers)
     * @param   y       (neue y-Koordinate des Schlaegers)
     */
    public Schlaeger(String farbe, int x, int y)
    {
       this.breite = 10;
       this.hoehe = 100;
       this.farbe = farbe;
       this.x = x;
       this.y = y;
       this.vX = 0;
       this.vY = 1;
       
       this.symbol = new RECHTECK();
       this.symbol.setzeGroesse(this.breite, this.hoehe);
       this.symbol.setzeFarbe(this.farbe);
       this.symbol.setzeMittelpunkt(this.x, this.y);
    }
    
    
    /**
     * Konstruktor fuer Objekte der Klasse Schlaeger.
     * 
     * @param   farbe   (neue Farbe des Schlaegers)
     * @param   x       (neue x-Koordinate des Schlagers)
     * @param   y       (neue y-Koordinate des Schlaegers)
     */
    public Schlaeger(int x, int y)
    {
       this.breite = 10;
       this.hoehe = 100;
       this.farbe = "blau";
       this.x = x;
       this.y = y;
       this.vX = 0;
       this.vY = 1;
       
       this.symbol = new RECHTECK();
       this.symbol.setzeGroesse(this.breite, this.hoehe);
       this.symbol.setzeFarbe(this.farbe);
       this.symbol.setzeMittelpunkt(this.x, this.y);
    }
    
    
    
    //  G E T T E R - M E T H O D E N
    
    /**
     * Methode zum Nennen der Breite des Schlaegers.
     * 
     * @return  breite  (aktuelle Breite des Schlaegers)
     */
    public int nenneBreite() {
        return this.breite;
    }
    
    
    /**
     * Methode zum Nennen der Hoehe des Schlaegers.
     * 
     * @return  hoehe  (aktuelle Hoehe des Schlaegers)
     */
    public int nenneHoehe() {
        return this.hoehe;
    }
    
    
    /**
     * Methode zum Nennen der Farbe des Schlaegers.
     * 
     * @return  farbe  (aktuelle Farbe des Schlaegers)
     */
    public String nenneFarbe() {
        return this.farbe;
    }
    
    
    /**
     * Methode zum Nennen der x-Koordinate des Schlaegers.
     * 
     * @return  x  (aktuelle x-Koordinate des Schlaegers)
     */
    public int nenneX() {
        return this.x;
    }
    
    
    /**
     * Methode zum Nennen der y-Koordinate des Schlaegers.
     * 
     * @return  y  (aktuelle y-Koordinate des Schlaegers)
     */
    public int nenneY() {
        return this.y;
    }
    
    
    /**
     * Methode zum Nennen der Geschwindigkeit des Schlaegers in x-Richtung.
     * 
     * @return  vX  (aktuelle Geschwindigkeit des Schlaegers in x-Richtung)
     */
    public int nenneVX() {
        return this.vX;
    }
    
    
    /**
     * Methode zum Nennen der Geschwindigkeit des Schlaegers in y-Richtung.
     * 
     * @return  vY  (aktuelle Geschwindigkeit des Schlaegers in y-Richtung)
     */
    public int nenneVY() {
        return this.vY;
    }
    
    
    
    //  S E T T E R - M E T H O D E N
    
    /**
     * Methode zum Setzen der Breite des Schaelgers.
     * 
     * @param   breite  (neue Breite des Schlaegers)
     */
    public void setzeBreite(int breite) {
        this.breite = breite;
        this.symbol.setzeGroesse(this.breite, this.hoehe);
    }
    
    
    /**
     * Methode zum Setzen der Hoehe des Schaelgers.
     * 
     * @param   hoehe  (neue Hoehe des Schlaegers)
     */
    public void setzeHoehe(int hoehe) {
        this.breite = hoehe;
        this.symbol.setzeGroesse(this.breite, this.hoehe);
    }
    
    
    /**
     * Methode zum Setzen der Farbe des Schaelgers.
     * 
     * @param   farbe  (neue Farbe des Schlaegers)
     */
    public void setzeFarbe(String farbe) {
        this.farbe = farbe;
        this.symbol.setzeFarbe(this.farbe);
    }
    
    
    /**
     * Methode zum Setzen der x-Koordinate des Schaelgers.
     * 
     * @param   x     (neue x-Koordinate des Schlaegers)
     */
    public void setzeX(int x) {
        this.x = x;
        this.symbol.setzeMittelpunkt(this.x, this.y);
    }
    
    
    /**
     * Methode zum Setzen der y-Koordinate des Schaelgers.
     * 
     * @param   y     (neue y-Koordinate des Schlaegers)
     */
    public void setzeY(int y) {
        this.y = y;
        this.symbol.setzeMittelpunkt(this.x, this.y);
    }
    
    
    /**
     * Methode zum Setzen der Geschwindigkeit des Schaelgers in x-Richtung.
     * 
     * @param   vX     (neue Geschwindigkeit des Schaelgers in x-Richtung)
     */
    public void setzeVX(int vX) {
        this.vX = vX;
    }
    
    
    /**
     * Methode zum Setzen der Geschwindigkeit des Schaelgers in y-Richtung.
     * 
     * @param   vY     (neue Geschwindigkeit des Schaelgers in y-Richtung)
     */
    public void setzeVY(int vY) {
        this.vY = vY;
    }
    
    
    
    //  W E I T E R E   M E T H O D E N
    
    /**
     * Methode zum Bewegen des Schlaegers mit der aktuellen Geschwindigkeit in x- und y-Richtung.
     * 
     */public void bewegen() {
        
        if ( this.x < 50 ) {
            this.vX = 0;
            this.x = 50;
        }
        else if ( this.x > 750 ) {
            this.vX = 0;
            this.x = 750;
        }
        else {
            this.x = this.x + this.vX;
            //this.y = this.y + this.vY;
        }
        
        this.symbol.setzeMittelpunkt(this.x, this.y);
    }
    
    
    
    /**
     * Methode zum Verringern der Geschwindigkeit des Schlaegers in y-Richtung.
     * Der Ball wird dadurch nach unten langsamer oder nach oben schneller.
     * 
     */
    public void verringereVY() {
        if (this.vY > -10) {
            this.vY = this.vY - 1;
        }
    }
    
    
    /**
     * Methode zum Erhoehen der Geschwindigkeit des Schlaegers in y-Richtung.
     * Der Ball wird dadurch nach unten schneller oder nach oben langsamer.
     * 
     */
    public void erhoeheVY() {
        if (this.vY < 10) {
            this.vY = this.vY + 1;
        }
    }
    
    /**
     * Methode zum Verringern der Geschwindigkeit des Schlaegers in y-Richtung.
     * Der Ball wird dadurch nach unten langsamer oder nach oben schneller.
     * 
     */
    public void links() {
        if (this.vX > -3) {
            this.vX = this.vX - 1;
        }
    }
    
    
    /**
     * Methode zum Erhoehen der Geschwindigkeit des Schlaegers in y-Richtung.
     * Der Ball wird dadurch nach unten schneller oder nach oben langsamer.
     * 
     */
    public void rechts() {
        if (this.vX < 3) {
            this.vX = this.vX + 1;
        }
    }
    
    
}
